Attribute VB_Name = "ModZip"
Option Explicit


'--this module contains everything needed to create zip files with the
'-- zip32.dll from Info-ZIP
'-- http://www.cdrom.com/pub/infozip/infozip.html

'-- SFX files (self-executing files) can also be made by simply
'-- writing a new file with the bytes of an SFX stub in front of the
'-- zip bytes. There are various versions of stubs available on the web.
'-- Info-ZIP also has sample code in C++ for making SFX stubs.

'-- The version of Zip32.dll used here is v. 2.3

'-- This code has been packaged as a sample program because the
' Info-ZIP dll can be confusing to use in VB. There's lots of
' documentation in C++ but very little in VB. I found that some
' aspects of the zip function never seemed to work quite right.
' In particular, most VB samples had code that was limited to
' a zip file with no compression, apparently because of confusion
' over how to send the compression value of ZPOPT.flevel

' By using sample code from several VB samples I came up with
' this simple version of zip making that seems to work well.
' There's no code here for unzip. Sorry. I haven't had occasion
' to need Unzip.


'-////////////////////////////////////////////////////////////////////////

'-- Public Constants
'-- Error codes for ZpArchive return:
'Public Const ZE_OK = 0              ' Success (No Error)
'Public Const ZE_EOF = 2             ' Unexpected End Of Zip File Error
'Public Const ZE_FORM = 3            ' Zip File Structure Error
'Public Const ZE_MEM = 4             ' -out Of Memory Error
'Public Const ZE_LOGIC = 5           ' Internal Logic Error
'Public Const ZE_BIG = 6             ' Entry Too Large To Split Error
'Public Const ZE_NOTE = 7            ' Invalid Comment Format Error
'Public Const ZE_TEST = 8            ' Zip Test (-T) Failed Or Out Of Memory Error
'Public Const ZE_ABORT = 9           ' User Interrupted Or Termination Error
'Public Const ZE_TEMP = 10           ' Error Using A Temp File
'Public Const ZE_READ = 11           ' Read Or Seek Error
'Public Const ZE_NONE = 12           ' Nothing To Do Error
'Public Const ZE_NAME = 13           ' Missing Or Empty Zip File Error
'Public Const ZE_WRITE = 14          ' Error Writing To A File
'Public Const ZE_CREAT = 15          ' Could't Open To Write Error
'Public Const ZE_PARMS = 16          ' Bad Command Line Argument Error
'Public Const ZE_OPEN = 18           ' Could Not Open A Specified File To Read Error

Private Type ZIPnames
    sNames(0 To 99) As String
End Type

Private Type CBChar
    ch(0 To 4096) As Byte
End Type

Private Type CBCh
    ch(0 To 255) As Byte
End Type

Private Type ZIPUSERFUNCTIONS
    lPtrPrint As Long
    lptrPassword As Long
    lptrComment As Long
    lptrService As Long
End Type

Private Type ZPOPT
  Date           As String ' US Date (8 Bytes Long) "12/31/98"?
  szRootDir      As String ' Root Directory Pathname (Up To 256 Bytes Long)
  szTempDir      As String ' Temp Directory Pathname (Up To 256 Bytes Long)
  fTemp          As Long     ' 1 If Temp dir Wanted, Else 0
  fSuffix        As Long     ' Include Suffixes (Not Yet Implemented!)
  fEncrypt       As Long     ' 1 If Encryption Wanted, Else 0
  fSystem        As Long     ' 1 To Include System/Hidden Files, Else 0
  fVolume        As Long     ' 1 If Storing Volume Label, Else 0
  fExtra         As Long     ' 1 If Excluding Extra Attributes, Else 0
  fNoDirEntries  As Long     ' 1 If Ignoring Directory Entries, Else 0
  fExcludeDate   As Long     ' 1 If Excluding Files Earlier Than Specified Date, Else 0
  fIncludeDate   As Long     ' 1 If Including Files Earlier Than Specified Date, Else 0
  fVerbose       As Long     ' 1 If Full Messages Wanted, Else 0
  fQuiet         As Long     ' 1 If Minimum Messages Wanted, Else 0
  fCRLF_LF       As Long     ' 1 If Translate CR/LF To LF, Else 0
  fLF_CRLF       As Long     ' 1 If Translate LF To CR/LF, Else 0
  fJunkDir       As Long     ' 1 If Junking Directory Names, Else 0
  fGrow          As Long   ' 1 If Allow Appending To Zip File, Else 0
  fForce         As Long     ' 1 If Making Entries Using DOS File Names, Else 0
  fMove          As Long     ' 1 If Deleting Files Added Or Updated, Else 0
  fDeleteEntries As Long     ' 1 If Files Passed Have To Be Deleted, Else 0
  fUpdate        As Long     ' 1 If Updating Zip File-Overwrite Only If Newer, Else 0
  fFreshen       As Long     ' 1 If Freshing Zip File-Overwrite Only, Else 0
  fJunkSFX       As Long     ' 1 If Junking SFX Prefix, Else 0
  fLatestTime    As Long     ' 1 If Setting Zip File Time To Time Of Latest File In Archive, Else 0
  fComment       As Long     ' 1 If Putting Comment In Zip File, Else 0
  fOffsets       As Long     ' 1 If Updating Archive Offsets For SFX Files, Else 0 ***
  fPrivilege     As Long     ' 1 If Not Saving Privileges, Else 0
  fEncryption    As Long     ' Read Only Property
  fRecurse       As Long     ' 1 (-r), 2 (-R) If Recursing Into Sub-Directories, Else 0
  fRepair        As Long     ' 1 = Fix Archive, 2 = Try Harder To Fix, Else 0
  flevel         As Byte  '***--some code samples say flevel should be set to 0. 0 is no compression!
End Type                   ' flevel value can be 0 to 9, with 9 being greatest compression.

Public Const MAX_PATH As Long = 255

Public Declare Function ZpInit Lib "zip32.dll" (ByRef tUserFn As ZIPUSERFUNCTIONS) As Long
Public Declare Function ZpSetOptions Lib "zip32.dll" (ByRef tOpts As ZPOPT) As Long
Public Declare Function ZpArchive Lib "zip32.dll" (ByVal argc As Long, ByVal funame As String, ByRef argv As ZIPnames) As Long

Public Function ZipIt(sFilePaths As Variant, LNum As Long, ByVal sPath As String, ByVal bComp As Byte, FullPath As Boolean) As Long
  '-- make the zip file. send in string array of file names, number of files,
  '-- path of zip to make, compression level, boolean value whether to conserve relative folder path inside zip.
 Dim ZOpts As ZPOPT
 Dim ZUserOpts As ZIPUSERFUNCTIONS
 Dim aZipName As ZIPnames
 Dim LRet As Long, i As Long
 Dim sZipFile As String, s1 As String
 Dim sFolPath As String, sCurPath As String, sDrive As String
 Dim Pt1 As Long
 On Error GoTo woops
    
  Pt1 = InStrRev(sPath, "\")
  sFolPath = Left$(sPath, Pt1) '--folder path for zip.
  sZipFile = Right$(sPath, (Len(sPath) - Pt1))
  sDrive = Left$(sFolPath, 1)
  sCurPath = CurDir$
  
 With ZOpts
  .Date = vbNullString
  .szRootDir = sFolPath
  .fTemp = 0
  .fSuffix = 0
  .fEncrypt = 0
  .fSystem = 1      ' 1 To Include System/Hidden Files, Else 0
  .fVolume = 0
  .fExtra = 0
  .fNoDirEntries = 0
  .fExcludeDate = 0
  .fIncludeDate = 0
  .fVerbose = 0
  .fQuiet = 0
  .fCRLF_LF = 0
  .fLF_CRLF = 0
  .fJunkDir = 0
  .fGrow = 0
  .fForce = 0
  .fMove = 0
  .fDeleteEntries = 0
  .fUpdate = 0
  .fFreshen = 0
  .fJunkSFX = 0
  .fLatestTime = 0
  .fComment = 0
  .fOffsets = 0
  .fPrivilege = 0
'  .fEncryption    ' Read Only
  .fRecurse = 0
  .fRepair = 0
  .flevel = Asc(bComp)     '-- some zip32 samples say that flevel must be set to 0
                       '-- 0 is no compression! Compression setting will work if
                       '-- it's sent as above: Asc(x) in which x = 0 - 9
             
    
  End With
  
    '-- if files are not to be zipped with relative folder paths intact:
       If (FullPath = False) Then ZOpts.fJunkDir = 1
       
   On Error Resume Next
    '--zip is not written based on full path. ZpArchive function takes
    '--only a file name and writes the zip file to the current directory.
    '-- So CurDir is changed here and then changed back at the end.
    
     ChDrive sDrive
     ChDir sFolPath
   On Error GoTo woops
    
    '-- addresses of callback functions for extra elements like
    '-- password protection and embedded file comment. In this function
    '-- the extras have not been coded. The callbacks have been written
    '-- only as necessary for the function.
    
   ZUserOpts.lPtrPrint = plAddressOf(AddressOf ZipPrintCallback)
   ZUserOpts.lptrPassword = plAddressOf(AddressOf ZipPasswordCallback)
   ZUserOpts.lptrComment = plAddressOf(AddressOf ZipCommentCallback)
   ZUserOpts.lptrService = plAddressOf(AddressOf ZipServiceCallback)
      
   LRet = ZpInit(ZUserOpts)
 
   LRet = ZpSetOptions(ZOpts)
 
   If LNum = 1 Then
     aZipName.sNames(0) = sFilePaths(0)
     aZipName.sNames(1) = vbNullChar
   Else
     For i = 0 To (LNum - 1)
         aZipName.sNames(i) = sFilePaths(i)
     Next i
       aZipName.sNames(LNum) = vbNullChar
   End If

     LRet = ZpArchive(LNum, sZipFile, aZipName)
     
  ChDir sCurPath
   ZipIt = LRet '--return zip32 error code (see above at top of page)
  Exit Function
woops:
  ZipIt = 100 '-- function error. 0 = success. 2-18 = zip32 error code.
End Function
Private Function plAddressOf(ByVal lPtr As Long) As Long
   ' VB Bug workaround fn
   plAddressOf = lPtr
End Function

Private Function ZipServiceCallback(ByRef mname As CBChar, ByVal X As Long) As Long
  '--this callback will send names and sizes of files being zipped if desired.
  On Error Resume Next
    ZipServiceCallback = 0
End Function

Private Function ZipPrintCallback(ByRef fname As CBChar, ByVal X As Long) As Long
  Dim iPos As Long
  Dim sFile As String
   On Error Resume Next
    DoEvents
    ZipPrintCallback = 0
End Function

Private Function ZipCommentCallback(ByRef sChar As CBChar) As Long
  On Error Resume Next
   sChar.ch(0) = vbNullString
   ZipCommentCallback = 1
End Function

Private Function ZipPasswordCallback(ByRef pwd As CBCh, ByVal X As Long, ByRef s2 As CBCh, ByRef Name As CBCh) As Long
  On Error Resume Next
    ' The default:
   ZipPasswordCallback = 1
End Function


